///home/berryj/link/bin/genMethods "-t" "Attribute<int>*" "-I" "LINK/graph/Attribute.h" "-d" "graph" "-y" "display_attribute_intptr" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/graph/Attribute.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>

void display_attribute_intptr(SCM, SCM, int);

typedef Attribute<int>* _Attribute_int__;

#define _Attribute_int__DATA(x) ((Attribute<int>**) (EXTDATA(x)))
#define _Attribute_int__IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Attribute<int>* >::type))
#define _Attribute_int__ISNT_DATA(x) (!_Attribute_int__IS_DATA(x))

#define _Attribute_int__CXX_DATA(x) (*(Attribute<int>**) (EXTDATA(VAL(x))))
#define _Attribute_int__CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Attribute<int>* >::type))
#define _Attribute_int__CXX_ISNT_DATA(x) (!_Attribute_int__CXX_IS_DATA(x))


static SCM is_Attribute_int__(SCM i)
{
	if (_Attribute_int__CXX_IS_DATA(i))
		return Truth;
	return Ntruth;
}

PRIMITIVE STk_init__Attribute_int__()
{
	Wrapper<_Attribute_int__>::type = STk_new_CXXwrapper_id(
			Wrapper<_Attribute_int__>::name, 
			"",
			(void (*)(SCM x, SCM port, int mode))
			display_attribute_intptr,
			(void (*)(SCM x))0,
			(void (*)(SCM x))0);
	Tcl_InitHashTable(&Register<_Attribute_int__>::objTable, TCL_ONE_WORD_KEYS);
	STk_add_new_cpp_primitive("Attribute-int?", tc_subr_1,
	(PRIMITIVE (*)(...))  is_Attribute_int__);
	return UNDEFINED;
}

void genExtra_Attribute_int__Methods(void);

PRIMITIVE STk_init_methods__Attribute_int__()
{
	genExtra_Attribute_int__Methods();
	return UNDEFINED;
}
